clear all;
% ------------------------ Paramtres-----------------------------------%

R = 1; % rayon de la roue (m? cm?)
alpha1 = pi/4; % angle du train avant (deg?rad?)
alpha2 = pi/6; % angle du train arrire (deg?rad?)
a = 1; % distance entre le centre de gravit et le train avant (m? cm?)
b = 1; % distance entre le centre de gravit et le train arrire (m? cm?)
c = 1; % distance entre le centre du train et la roue (m? cm?)
tetapoint1 = 1 ; % vitesse angulaire de la roue 1 (avant gauche) (rad^-1 ?)
tetapoint2 = 1 ; % vitesse angulaire de la roue 2 (avant droit) (rad^-1 ?)
tetapoint3 = 1 ; % vitesse angulaire de la roue 3 (arrire droit) (rad^-1 ?)
tetapoint4 = 1 ; % vitesse angulaire de la roue 4 (arrire gauche) (rad^-1 ?)

%------------------------- Modle cinmatique du Robucar-------------------------------------------- %

M = [R/4*cos(alpha1), R/4*sin(alpha1), 1; R/4*cos(alpha1), R/4*sin(alpha1), R*(cos(alpha1)/(2*c) + sin(alpha1)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), -R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b))]
X = [tetapoint1 ; tetapoint2 ; tetapoint3 ; tetapoint4];
A=M';
V = A*X;
[Q,R]=qr(A);
Xs=R\(Q'*V)



