/* Include files */
#include "test_sfun.h"
#include "c3_test.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "test_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c3_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc3_testInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c3_test(void);
static void initialize_params_c3_test(void);
static void enable_c3_test(void);
static void disable_c3_test(void);
static void finalize_c3_test(void);
static void sf_c3_test(void);
static real_T *c3_axe_y(void);
static real_T *c3_axe_z(void);
static real_T *c3_acce(void);
static real_T *c3_pedal_frein_s(void);
static real_T *c3_consigne_s(void);
static real_T *c3_vitesse_r(void);
static real_T *c3_consigne(void);
static real_T *c3_pedal_frein(void);
static void init_dsm_address_info(void);
static void sf_save_state_c3_test(FILE *c3_file);
static void sf_load_state_c3_test(FILE *c3_file);

/* Function Definitions */
static void initialize_c3_test(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c3_is_active_c3_test = 0U;
}

static void initialize_params_c3_test(void)
{
}

static void enable_c3_test(void)
{
}

static void disable_c3_test(void)
{
}

static void finalize_c3_test(void)
{
}

static void sf_c3_test(void)
{
  uint8_T c3_previousEvent;
  real_T c3_b_axe_y;
  real_T c3_b_axe_z;
  real_T c3_b_acce;
  real_T c3_b_pedal_frein_s;
  real_T c3_b_consigne_s;
  real_T c3_b_vitesse_r;
  real_T c3_pedal_acc;
  real_T c3_consigne_mes;
  real_T c3_test;
  real_T c3_b_pedal_frein;
  real_T c3_b_consigne;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK(*c3_axe_y(), 6U);
  _SFD_DATA_RANGE_CHECK(*c3_axe_z(), 1U);
  _SFD_DATA_RANGE_CHECK(*c3_acce(), 4U);
  _SFD_DATA_RANGE_CHECK(*c3_pedal_frein_s(), 3U);
  _SFD_DATA_RANGE_CHECK(*c3_consigne_s(), 0U);
  _SFD_DATA_RANGE_CHECK(*c3_vitesse_r(), 2U);
  _SFD_DATA_RANGE_CHECK(*c3_consigne(), 5U);
  _SFD_DATA_RANGE_CHECK(*c3_pedal_frein(), 7U);
  c3_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,2);
  c3_b_axe_y = *c3_axe_y();
  c3_b_axe_z = *c3_axe_z();
  c3_b_acce = *c3_acce();
  c3_b_pedal_frein_s = *c3_pedal_frein_s();
  c3_b_consigne_s = *c3_consigne_s();
  c3_b_vitesse_r = *c3_vitesse_r();
  sf_debug_push_symbol_scope(11U, 0U);
  sf_debug_symbol_scope_add_symbol("pedal_acc", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c3_pedal_acc, 0);
  sf_debug_symbol_scope_add_symbol("consigne_mes", 0, 0U, 0U, 0U, 0U, 1.0, 0,
   0.0, 0U, 0, 0U, 0, &c3_consigne_mes, 0);
  sf_debug_symbol_scope_add_symbol("test", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c3_test, 0);
  sf_debug_symbol_scope_add_symbol("pedal_frein", 0, 0U, 0U, 0U, 0U, 1.0, 0,
   0.0, 0U, 0, 0U, 0, &c3_b_pedal_frein, 0);
  sf_debug_symbol_scope_add_symbol("consigne", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c3_b_consigne, 0);
  sf_debug_symbol_scope_add_symbol("vitesse_r", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c3_b_vitesse_r, 0);
  sf_debug_symbol_scope_add_symbol("consigne_s", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c3_b_consigne_s, 0);
  sf_debug_symbol_scope_add_symbol("pedal_frein_s", 0, 0U, 0U, 0U, 0U, 1.0, 0,
   0.0, 0U, 0, 0U, 0, &c3_b_pedal_frein_s, 0);
  sf_debug_symbol_scope_add_symbol("acce", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c3_b_acce, 0);
  sf_debug_symbol_scope_add_symbol("axe_z", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c3_b_axe_z, 0);
  sf_debug_symbol_scope_add_symbol("axe_y", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c3_b_axe_y, 0);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
  c3_b_consigne = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  c3_test = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
  c3_b_pedal_frein_s = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
  c3_consigne_mes = c3_b_vitesse_r * 25.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,10);
  c3_pedal_acc = -0.5 * c3_b_axe_z + 50.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,11);
  c3_b_pedal_frein = -0.5 * c3_b_axe_y + 50.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,29);
  if(CV_EML_IF(0, 0, c3_b_pedal_frein == 0.0)) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,32);
    if(CV_EML_IF(0, 1, c3_b_acce == 0.0)) {
      /* consigne_angle_direction = 4512 - 5.15*axe_x; */
      /* alpha1=0;   % a calculer  partir de consigne_angle_direction (convertion -> rad ou  ) */
      /* alpha2=0;   % a calculer  partir de consigne_angle_direction (convertion -> rad ou  ) */
      /* 
         A1 = [R/4*cos(alpha1), R/4*sin(alpha1), 1; R/4*cos(alpha1), R/4*sin(alpha1), R*(cos(alpha1)/(2*c) + sin(alpha1)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b)); R/4*cos(alpha2), R/4*sin(alpha2), -R*(cos(alpha2)/(2*c) + sin(alpha2)/(a+b))] */
      /* A = A1'; */
      /* V = [;0] ; */
      /* [Q,R]=qr(A); */
      /* Xs=R\(Q'*V) */
      /* tetapt1=Xs[1]; */
      /* tetapt2=Xs[2]; */
      /* tetapt3=Xs[3]; */
      /* tetapt4=Xs[4]; */
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,33);
      c3_b_consigne = 0.0;
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,34);
      c3_b_consigne_s = c3_b_consigne;
    }
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,37);
    if(CV_EML_IF(0, 2, c3_b_acce == 1.0)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,39);
      if(CV_EML_IF(0, 3, c3_pedal_acc == 0.0)) {
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,40);
        c3_b_consigne = c3_b_consigne_s;
      } else {
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,42);
        c3_b_consigne = c3_pedal_acc * 0.15;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,43);
        c3_b_consigne_s = c3_b_consigne;
      }
    }
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,49);
    if(CV_EML_IF(0, 4, c3_b_acce == 2.0)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,51);
      if(CV_EML_COND(0, 0, c3_pedal_acc == 0.0) || CV_EML_COND(0, 1,
        c3_b_consigne_s < 10.0)) {
        CV_EML_MCDC(0, 0, true);
        CV_EML_IF(0, 5, true);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,52);
        c3_b_consigne = c3_b_consigne_s;
      } else {
        CV_EML_MCDC(0, 0, false);
        CV_EML_IF(0, 5, false);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,54);
        c3_b_consigne = 15.0 + c3_pedal_acc * 0.15;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,55);
        c3_b_consigne_s = c3_b_consigne;
      }
    }
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,60);
    if(CV_EML_IF(0, 6, c3_b_acce == 3.0)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,62);
      if(CV_EML_COND(0, 2, c3_pedal_acc == 0.0) || CV_EML_COND(0, 3,
        c3_b_consigne_s < 25.0)) {
        CV_EML_MCDC(0, 1, true);
        CV_EML_IF(0, 7, true);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,63);
        c3_b_consigne = c3_b_consigne_s;
      } else {
        CV_EML_MCDC(0, 1, false);
        CV_EML_IF(0, 7, false);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,65);
        c3_b_consigne = 30.0 + c3_pedal_acc * 0.2;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,66);
        c3_b_consigne_s = c3_b_consigne;
      }
    }
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,71);
    if(CV_EML_IF(0, 8, c3_b_acce == 4.0)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,73);
      if(CV_EML_COND(0, 4, c3_pedal_acc == 0.0) || CV_EML_COND(0, 5,
        c3_b_consigne_s < 45.0)) {
        CV_EML_MCDC(0, 2, true);
        CV_EML_IF(0, 9, true);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,74);
        c3_b_consigne = c3_b_consigne_s;
      } else {
        CV_EML_MCDC(0, 2, false);
        CV_EML_IF(0, 9, false);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,76);
        c3_b_consigne = 50.0 + c3_pedal_acc * 0.25;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,77);
        c3_b_consigne_s = c3_b_consigne;
      }
    }
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,82);
    if(CV_EML_IF(0, 10, c3_b_acce == 5.0)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,84);
      if(CV_EML_COND(0, 6, c3_pedal_acc == 0.0) || CV_EML_COND(0, 7,
        c3_b_consigne_s < 70.0)) {
        CV_EML_MCDC(0, 3, true);
        CV_EML_IF(0, 11, true);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,85);
        c3_b_consigne = c3_b_consigne_s;
      } else {
        CV_EML_MCDC(0, 3, false);
        CV_EML_IF(0, 11, false);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,87);
        c3_b_consigne = 75.0 + c3_pedal_acc * 0.25;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,88);
        c3_b_consigne_s = c3_b_consigne;
      }
    }
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,95);
    if(CV_EML_IF(0, 12, c3_b_pedal_frein > c3_b_pedal_frein_s)) {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,97);
      if(CV_EML_IF(0, 13, c3_consigne_mes * (1.0 - c3_b_pedal_frein * 0.1) <
        0.0)) {
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,98);
      } else {
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,100);
        c3_b_consigne = c3_consigne_mes * (1.0 - c3_b_pedal_frein * 0.1);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,101);
        c3_b_consigne_s = c3_b_consigne;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,102);
        c3_b_pedal_frein_s = c3_b_pedal_frein;
      }
    } else {
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,107);
      c3_b_consigne = c3_b_consigne_s;
    }
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-107);
  sf_debug_pop_symbol_scope();
  *c3_consigne() = c3_b_consigne;
  *c3_pedal_frein() = c3_b_pedal_frein;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,2);
  _sfEvent_ = c3_previousEvent;
  sf_debug_check_for_state_inconsistency(_testMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static real_T *c3_axe_y(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real_T *c3_axe_z(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real_T *c3_acce(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static real_T *c3_pedal_frein_s(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
}

static real_T *c3_consigne_s(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 4);
}

static real_T *c3_vitesse_r(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 5);
}

static real_T *c3_consigne(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real_T *c3_pedal_frein(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
}

static void init_dsm_address_info(void)
{
}

static void sf_save_state_c3_test(FILE *c3_file)
{
  fwrite(&chartInstance.c3_is_active_c3_test, 1,
   sizeof(chartInstance.c3_is_active_c3_test), c3_file);
}

static void sf_load_state_c3_test(FILE *c3_file)
{
  fread(&chartInstance.c3_is_active_c3_test, 1,
   sizeof(chartInstance.c3_is_active_c3_test), c3_file);
}

/* SFunction Glue Code */
void sf_c3_test_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1481113577U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1342268881U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2859768891U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(2161927247U);
}

mxArray *sf_c3_test_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(77144591U);
    pr[1] = (double)(431363784U);
    pr[2] = (double)(2212642260U);
    pr[3] = (double)(2397124752U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,6,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,5,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,5,"type",mxType);
    }
    mxSetField(mxData,5,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,2,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S)
{
  if(ssIsFirstInitCond(S)) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_testMachineNumber_,
         3,
         1,
         1,
         8,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_testMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_testMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(6,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"axe_y",0);
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"axe_z",0);
          _SFD_SET_DATA_PROPS(4,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"acce",0);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"pedal_frein_s",0);
          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"consigne_s",0);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"vitesse_r",0);
          _SFD_SET_DATA_PROPS(5,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"consigne",0);
          _SFD_SET_DATA_PROPS(7,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"pedal_frein",0);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,14,0,0,0,8,4);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,2707);
        _SFD_CV_INIT_EML_IF(0,0,933,951,2306,2682);
        _SFD_CV_INIT_EML_IF(0,1,966,978,-1,1060);
        _SFD_CV_INIT_EML_IF(0,2,1066,1077,-1,-2);
        _SFD_CV_INIT_EML_IF(0,3,1114,1130,1182,1285);
        _SFD_CV_INIT_EML_IF(0,4,1332,1343,-1,-2);
        _SFD_CV_INIT_EML_IF(0,5,1372,1407,1454,1554);
        _SFD_CV_INIT_EML_IF(0,6,1581,1592,-1,-2);
        _SFD_CV_INIT_EML_IF(0,7,1612,1647,1694,1787);
        _SFD_CV_INIT_EML_IF(0,8,1814,1825,-1,-2);
        _SFD_CV_INIT_EML_IF(0,9,1847,1882,1933,2034);
        _SFD_CV_INIT_EML_IF(0,10,2056,2067,-1,-2);
        _SFD_CV_INIT_EML_IF(0,11,2089,2124,2176,2279);
        _SFD_CV_INIT_EML_IF(0,12,2327,2358,2614,2677);
        _SFD_CV_INIT_EML_IF(0,13,2377,2419,2452,2599);
        {
          static int condStart[] = {1375,1391};
          static int condEnd[] = {1387,1406};
          static int pfixExpr[] = {0,1,-2};
          _SFD_CV_INIT_EML_MCDC(0,0,1375,1406,2,0,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        {
          static int condStart[] = {1615,1631};
          static int condEnd[] = {1627,1646};
          static int pfixExpr[] = {0,1,-2};
          _SFD_CV_INIT_EML_MCDC(0,1,1615,1646,2,2,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        {
          static int condStart[] = {1850,1866};
          static int condEnd[] = {1862,1881};
          static int pfixExpr[] = {0,1,-2};
          _SFD_CV_INIT_EML_MCDC(0,2,1850,1881,2,4,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        {
          static int condStart[] = {2092,2108};
          static int condEnd[] = {2104,2123};
          static int pfixExpr[] = {0,1,-2};
          _SFD_CV_INIT_EML_MCDC(0,3,2092,2123,2,6,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(6U, c3_axe_y());
        _SFD_SET_DATA_VALUE_PTR(1U, c3_axe_z());
        _SFD_SET_DATA_VALUE_PTR(4U, c3_acce());
        _SFD_SET_DATA_VALUE_PTR(3U, c3_pedal_frein_s());
        _SFD_SET_DATA_VALUE_PTR(0U, c3_consigne_s());
        _SFD_SET_DATA_VALUE_PTR(2U, c3_vitesse_r());
        _SFD_SET_DATA_VALUE_PTR(5U, c3_consigne());
        _SFD_SET_DATA_VALUE_PTR(7U, c3_pedal_frein());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_testMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c3_test(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S);
  initialize_params_c3_test();
  initialize_c3_test();
}

static void sf_opaque_enable_c3_test(void *chartInstanceVar)
{
  enable_c3_test();
}

static void sf_opaque_disable_c3_test(void *chartInstanceVar)
{
  disable_c3_test();
}

static void sf_opaque_gateway_c3_test(void *chartInstanceVar)
{
  sf_c3_test();
}

static void sf_opaque_terminate_c3_test(void *chartInstanceVar)
{
  finalize_c3_test();
}

static void mdlProcessParameters_c3_test(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c3_test();
}

static void mdlSetWorkWidths_c3_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("test",3);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("test",3,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 5, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"test",3,6);
      sf_mark_chart_reusable_outputs(S,"test",3,2);
    }
    if (!sf_is_chart_instance_optimized_out("test",3)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("test",3);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(2850833856U));
  ssSetChecksum1(S,(338478819U));
  ssSetChecksum2(S,(1369208994U));
  ssSetChecksum3(S,(110291202U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c3_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "test", 3);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void sf_save_debug_c3_test(SFc3_testInstanceStruct* chartInstance, FILE*
 file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = sf_debug_get_state_vectors_data_size(machineNumber,
   chartNumber, instanceNumber);
  unsigned char* buffer = (unsigned char*) malloc(bufferSize);
  unsigned int chartActive = sf_debug_get_chart_active(machineNumber,
   chartNumber, instanceNumber);
  fwrite(&chartActive, sizeof(chartActive),1,file);
  sf_debug_get_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  fwrite(&bufferSize, sizeof(bufferSize), 1, file); /* Write number of bytes */
  fwrite(buffer, 1, bufferSize,file);   /* Write buffer */
  free(buffer);
}
static void sf_load_debug_c3_test(SFc3_testInstanceStruct* chartInstance,FILE*
 file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = 0;
  unsigned char* buffer = NULL;
  unsigned int chartActive = 0;
  fread(&chartActive, sizeof(chartActive),1,file);
  sf_debug_set_chart_active(machineNumber, chartNumber, instanceNumber,
   chartActive);
  fread(&bufferSize, sizeof(bufferSize), 1, file);
  buffer = (unsigned char*) malloc(bufferSize);
  fread(buffer, 1, bufferSize, file);
  sf_debug_set_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  free(buffer);
}
static void sf_c3_test_sim_ctx_io(SimStruct* S, const char io, FILE* file)
{
  if(io == 'r') {
    sf_load_state_c3_test(file);
    sf_load_debug_c3_test(&chartInstance, file);
  } else {
    sf_save_state_c3_test(file);
    sf_save_debug_c3_test(&chartInstance, file);
  }
}
static void mdlStart_c3_test(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c3_test;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c3_test;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c3_test;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c3_test;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c3_test;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c3_test;
  chartInstance.chartInfo.mdlStart = mdlStart_c3_test;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c3_test;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */
  ssSetmdlSimulationContextIO(S, sf_c3_test_sim_ctx_io);
  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c3_test_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c3_test(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c3_test(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c3_test(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c3_test_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

