/* Include files */
#include "test_sfun.h"
#include "c10_test.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "test_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c10_IN_NO_ACTIVE_CHILD          (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc10_testInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c10_test(void);
static void initialize_params_c10_test(void);
static void enable_c10_test(void);
static void disable_c10_test(void);
static void finalize_c10_test(void);
static void sf_c10_test(void);
static real_T *c10_rapport(void);
static real_T *c10_var(void);
static real_T *c10_marche_arriere(void);
static real_T *c10_var_s(void);
static void init_dsm_address_info(void);
static void sf_save_state_c10_test(FILE *c10_file);
static void sf_load_state_c10_test(FILE *c10_file);

/* Function Definitions */
static void initialize_c10_test(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c10_is_active_c10_test = 0U;
}

static void initialize_params_c10_test(void)
{
}

static void enable_c10_test(void)
{
}

static void disable_c10_test(void)
{
}

static void finalize_c10_test(void)
{
}

static void sf_c10_test(void)
{
  uint8_T c10_previousEvent;
  real_T c10_b_rapport;
  real_T c10_b_var;
  real_T c10_b_var_s;
  real_T c10_b_marche_arriere;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK(*c10_rapport(), 0U);
  _SFD_DATA_RANGE_CHECK(*c10_var(), 3U);
  _SFD_DATA_RANGE_CHECK(*c10_marche_arriere(), 2U);
  _SFD_DATA_RANGE_CHECK(*c10_var_s(), 1U);
  c10_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,9);
  c10_b_rapport = *c10_rapport();
  c10_b_var = *c10_var();
  c10_b_var_s = *c10_var_s();
  sf_debug_push_symbol_scope(4U, 0U);
  sf_debug_symbol_scope_add_symbol("marche_arriere", 0, 0U, 0U, 0U, 0U, 1.0, 0,
   0.0, 0U, 0, 0U, 0, &c10_b_marche_arriere, 0);
  sf_debug_symbol_scope_add_symbol("var_s", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c10_b_var_s, 0);
  sf_debug_symbol_scope_add_symbol("var", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   0U, 0, &c10_b_var, 0);
  sf_debug_symbol_scope_add_symbol("rapport", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c10_b_rapport, 0);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,5);
  c10_b_marche_arriere = c10_b_var_s;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  if(CV_EML_COND(0, 0, c10_b_var == 0.0) && CV_EML_COND(0, 1, c10_b_rapport ==
    0.0)) {
    CV_EML_MCDC(0, 0, true);
    CV_EML_IF(0, 0, true);
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
    c10_b_marche_arriere = 0.0;
  } else {
    CV_EML_MCDC(0, 0, false);
    CV_EML_IF(0, 0, false);
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
    if(CV_EML_COND(0, 2, c10_b_var == 1.0) && CV_EML_COND(0, 3, c10_b_rapport ==
      0.0)) {
      CV_EML_MCDC(0, 1, true);
      CV_EML_IF(0, 1, true);
      _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,10);
      c10_b_marche_arriere = 1.0;
    } else {
      CV_EML_MCDC(0, 1, false);
      CV_EML_IF(0, 1, false);
    }
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-10);
  sf_debug_pop_symbol_scope();
  *c10_marche_arriere() = c10_b_marche_arriere;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,9);
  _sfEvent_ = c10_previousEvent;
  sf_debug_check_for_state_inconsistency(_testMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static real_T *c10_rapport(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static real_T *c10_var(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real_T *c10_marche_arriere(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static real_T *c10_var_s(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static void init_dsm_address_info(void)
{
}

static void sf_save_state_c10_test(FILE *c10_file)
{
  fwrite(&chartInstance.c10_is_active_c10_test, 1,
   sizeof(chartInstance.c10_is_active_c10_test), c10_file);
}

static void sf_load_state_c10_test(FILE *c10_file)
{
  fread(&chartInstance.c10_is_active_c10_test, 1,
   sizeof(chartInstance.c10_is_active_c10_test), c10_file);
}

/* SFunction Glue Code */
void sf_c10_test_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(2021344288U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(1148276865U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2048326046U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(434302065U);
}

mxArray *sf_c10_test_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(959598655U);
    pr[1] = (double)(4071307584U);
    pr[2] = (double)(1027575989U);
    pr[3] = (double)(4269310557U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,3,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,1,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S)
{
  if(ssIsFirstInitCond(S)) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_testMachineNumber_,
         10,
         1,
         1,
         4,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_testMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_testMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(0,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"rapport",0);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"var",0);
          _SFD_SET_DATA_PROPS(2,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"marche_arriere",0);
          _SFD_SET_DATA_PROPS(1,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"var_s",0);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,4,2);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,302);
        _SFD_CV_INIT_EML_IF(0,0,179,205,231,293);
        _SFD_CV_INIT_EML_IF(0,1,231,260,-1,-2);
        {
          static int condStart[] = {184,194};
          static int condEnd[] = {190,204};
          static int pfixExpr[] = {0,1,-3};
          _SFD_CV_INIT_EML_MCDC(0,0,184,204,2,0,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        {
          static int condStart[] = {239,249};
          static int condEnd[] = {245,259};
          static int pfixExpr[] = {0,1,-3};
          _SFD_CV_INIT_EML_MCDC(0,1,239,259,2,2,&(condStart[0]),&(condEnd[0]),3,&(pfixExpr[0]));
        }
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(0U, c10_rapport());
        _SFD_SET_DATA_VALUE_PTR(3U, c10_var());
        _SFD_SET_DATA_VALUE_PTR(2U, c10_marche_arriere());
        _SFD_SET_DATA_VALUE_PTR(1U, c10_var_s());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_testMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c10_test(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S);
  initialize_params_c10_test();
  initialize_c10_test();
}

static void sf_opaque_enable_c10_test(void *chartInstanceVar)
{
  enable_c10_test();
}

static void sf_opaque_disable_c10_test(void *chartInstanceVar)
{
  disable_c10_test();
}

static void sf_opaque_gateway_c10_test(void *chartInstanceVar)
{
  sf_c10_test();
}

static void sf_opaque_terminate_c10_test(void *chartInstanceVar)
{
  finalize_c10_test();
}

static void mdlProcessParameters_c10_test(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c10_test();
}

static void mdlSetWorkWidths_c10_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("test",10);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("test",10,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"test",10,3);
      sf_mark_chart_reusable_outputs(S,"test",10,1);
    }
    if (!sf_is_chart_instance_optimized_out("test",10)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("test",10);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(1165698190U));
  ssSetChecksum1(S,(2499101772U));
  ssSetChecksum2(S,(642430872U));
  ssSetChecksum3(S,(2348288480U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c10_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "test", 10);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void sf_save_debug_c10_test(SFc10_testInstanceStruct* chartInstance,
 FILE* file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = sf_debug_get_state_vectors_data_size(machineNumber,
   chartNumber, instanceNumber);
  unsigned char* buffer = (unsigned char*) malloc(bufferSize);
  unsigned int chartActive = sf_debug_get_chart_active(machineNumber,
   chartNumber, instanceNumber);
  fwrite(&chartActive, sizeof(chartActive),1,file);
  sf_debug_get_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  fwrite(&bufferSize, sizeof(bufferSize), 1, file); /* Write number of bytes */
  fwrite(buffer, 1, bufferSize,file);   /* Write buffer */
  free(buffer);
}
static void sf_load_debug_c10_test(SFc10_testInstanceStruct* chartInstance,FILE*
 file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = 0;
  unsigned char* buffer = NULL;
  unsigned int chartActive = 0;
  fread(&chartActive, sizeof(chartActive),1,file);
  sf_debug_set_chart_active(machineNumber, chartNumber, instanceNumber,
   chartActive);
  fread(&bufferSize, sizeof(bufferSize), 1, file);
  buffer = (unsigned char*) malloc(bufferSize);
  fread(buffer, 1, bufferSize, file);
  sf_debug_set_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  free(buffer);
}
static void sf_c10_test_sim_ctx_io(SimStruct* S, const char io, FILE* file)
{
  if(io == 'r') {
    sf_load_state_c10_test(file);
    sf_load_debug_c10_test(&chartInstance, file);
  } else {
    sf_save_state_c10_test(file);
    sf_save_debug_c10_test(&chartInstance, file);
  }
}
static void mdlStart_c10_test(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c10_test;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c10_test;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c10_test;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c10_test;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c10_test;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c10_test;
  chartInstance.chartInfo.mdlStart = mdlStart_c10_test;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c10_test;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */
  ssSetmdlSimulationContextIO(S, sf_c10_test_sim_ctx_io);
  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c10_test_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c10_test(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c10_test(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c10_test(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c10_test_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

