/* Include files */
#include "test_sfun.h"
#include "c1_test.h"
#define CHARTINSTANCE_CHARTNUMBER       (chartInstance.chartNumber)
#define CHARTINSTANCE_INSTANCENUMBER    (chartInstance.instanceNumber)
#include "test_sfun_debug_macros.h"

/* Type Definitions */

/* Named Constants */
#define c1_IN_NO_ACTIVE_CHILD           (0)

/* Variable Declarations */

/* Variable Definitions */
static SFc1_testInstanceStruct chartInstance;

/* Function Declarations */
static void initialize_c1_test(void);
static void initialize_params_c1_test(void);
static void enable_c1_test(void);
static void disable_c1_test(void);
static void finalize_c1_test(void);
static void sf_c1_test(void);
static real_T *c1_e(void);
static int32_T *c1_codeur(void);
static real_T *c1_clk(void);
static real_T *c1_e_r(void);
static real_T *c1_e_pid(void);
static int32_T *c1_codeur_r(void);
static real_T *c1_inhibit(void);
static real_T *c1_e_w(void);
static int32_T *c1_codeur_w(void);
static void init_dsm_address_info(void);
static void sf_save_state_c1_test(FILE *c1_file);
static void sf_load_state_c1_test(FILE *c1_file);

/* Function Definitions */
static void initialize_c1_test(void)
{
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  chartInstance.c1_is_active_c1_test = 0U;
}

static void initialize_params_c1_test(void)
{
}

static void enable_c1_test(void)
{
}

static void disable_c1_test(void)
{
}

static void finalize_c1_test(void)
{
}

static void sf_c1_test(void)
{
  uint8_T c1_previousEvent;
  real_T c1_b_e;
  int32_T c1_b_codeur;
  real_T c1_b_clk;
  real_T c1_b_e_r;
  int32_T c1_b_codeur_r;
  int32_T c1_b_codeur_w;
  real_T c1_b_e_w;
  real_T c1_b_inhibit;
  real_T c1_b_e_pid;
  real_T c1_x;
  real_T c1_y;
  _sfTime_ = (real_T)ssGetT(chartInstance.S);
  _SFD_DATA_RANGE_CHECK(*c1_e(), 5U);
  _SFD_DATA_RANGE_CHECK((real_T)*c1_codeur(), 6U);
  _SFD_DATA_RANGE_CHECK(*c1_clk(), 8U);
  _SFD_DATA_RANGE_CHECK(*c1_e_r(), 2U);
  _SFD_DATA_RANGE_CHECK(*c1_e_pid(), 4U);
  _SFD_DATA_RANGE_CHECK((real_T)*c1_codeur_r(), 3U);
  _SFD_DATA_RANGE_CHECK(*c1_inhibit(), 0U);
  _SFD_DATA_RANGE_CHECK(*c1_e_w(), 1U);
  _SFD_DATA_RANGE_CHECK((real_T)*c1_codeur_w(), 7U);
  c1_previousEvent = _sfEvent_;
  _sfEvent_ = CALL_EVENT;
  _SFD_CC_CALL(CHART_ENTER_DURING_FUNCTION_TAG,0);
  c1_b_e = *c1_e();
  c1_b_codeur = *c1_codeur();
  c1_b_clk = *c1_clk();
  c1_b_e_r = *c1_e_r();
  c1_b_codeur_r = *c1_codeur_r();
  sf_debug_push_symbol_scope(9U, 0U);
  sf_debug_symbol_scope_add_symbol("codeur_w", 6, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c1_b_codeur_w, 0);
  sf_debug_symbol_scope_add_symbol("e_w", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   0U, 0, &c1_b_e_w, 0);
  sf_debug_symbol_scope_add_symbol("inhibit", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c1_b_inhibit, 0);
  sf_debug_symbol_scope_add_symbol("e_pid", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c1_b_e_pid, 0);
  sf_debug_symbol_scope_add_symbol("codeur_r", 6, 0U, 0U, 0U, 0U, 1.0, 0, 0.0,
   0U, 0, 0U, 0, &c1_b_codeur_r, 0);
  sf_debug_symbol_scope_add_symbol("e_r", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   0U, 0, &c1_b_e_r, 0);
  sf_debug_symbol_scope_add_symbol("clk", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   0U, 0, &c1_b_clk, 0);
  sf_debug_symbol_scope_add_symbol("codeur", 6, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U,
   0, 0U, 0, &c1_b_codeur, 0);
  sf_debug_symbol_scope_add_symbol("e", 0, 0U, 0U, 0U, 0U, 1.0, 0, 0.0, 0U, 0,
   0U, 0, &c1_b_e, 0);
  CV_EML_FCN(0, 0);
  /*  This block supports an embeddable subset of the MATLAB language. */
  /*  See the help menu for details.  */
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,6);
  c1_b_inhibit = 1.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,7);
  c1_b_e_pid = 0.0;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,8);
  c1_b_codeur_w = c1_b_codeur;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,9);
  c1_b_e_w = c1_b_e;
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,11);
  if(CV_EML_IF(0, 0, c1_b_clk < 5.0)) {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,13);
    c1_b_e_pid = 0.0;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,14);
    c1_b_inhibit = 1.0;
    /*  on attend 5 sec afin d'avoir les bonnes valeurs du codeur abs */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,15);
    c1_b_codeur_w = c1_b_codeur;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,16);
    c1_b_e_w = c1_b_e;
  } else {
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,20);
    if(CV_EML_COND(0, 0, (real_T)c1_b_codeur < 1402.0) || CV_EML_COND(0, 1,
      (real_T)c1_b_codeur > 2378.0)) {
    } else {
      c1_x = c1_b_e;
      c1_y = fabs(c1_x);
      if(CV_EML_COND(0, 2, c1_y < 5.0) || (CV_EML_COND(0, 3, c1_b_e_r != c1_b_e)
        && CV_EML_COND(0, 4, c1_b_codeur_r == c1_b_codeur))) {
      } else {
        CV_EML_MCDC(0, 0, false);
        CV_EML_IF(0, 1, false);
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,32);
        c1_b_e_pid = c1_b_e;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,33);
        c1_b_inhibit = 0.0;
        /*  commande de la direction en BF */
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,34);
        c1_b_codeur_w = c1_b_codeur;
        _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,35);
        c1_b_e_w = c1_b_e;
        goto label_1;
      }
    }
    CV_EML_MCDC(0, 0, true);
    CV_EML_IF(0, 1, true);
    /*  si le robucar tait teint (valeurs codeur fausses)  */
    /*  ou on est trs proche de la consigne  */
    /*  ou arduino dbranch (codeur abs non connect)          */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,25);
    c1_b_e_pid = 0.0;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,26);
    c1_b_inhibit = 1.0;
    /*  on arrte la commande de la direction en boucle ferme  */
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,27);
    c1_b_codeur_w = c1_b_codeur;
    _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,28);
    c1_b_e_w = c1_b_e;
    label_1:;
  }
  _SFD_EML_CALL(STATE_DURING_DURING_ACTION_TAG,0,-35);
  sf_debug_pop_symbol_scope();
  *c1_e_pid() = c1_b_e_pid;
  *c1_inhibit() = c1_b_inhibit;
  *c1_e_w() = c1_b_e_w;
  *c1_codeur_w() = c1_b_codeur_w;
  _SFD_CC_CALL(EXIT_OUT_OF_FUNCTION_TAG,0);
  _sfEvent_ = c1_previousEvent;
  sf_debug_check_for_state_inconsistency(_testMachineNumber_,
   chartInstance.chartNumber, chartInstance.instanceNumber);
}

static real_T *c1_e(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 0);
}

static int32_T *c1_codeur(void)
{
  return (int32_T *)ssGetInputPortSignal(chartInstance.S, 1);
}

static real_T *c1_clk(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 2);
}

static real_T *c1_e_r(void)
{
  return (real_T *)ssGetInputPortSignal(chartInstance.S, 3);
}

static real_T *c1_e_pid(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 1);
}

static int32_T *c1_codeur_r(void)
{
  return (int32_T *)ssGetInputPortSignal(chartInstance.S, 4);
}

static real_T *c1_inhibit(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 2);
}

static real_T *c1_e_w(void)
{
  return (real_T *)ssGetOutputPortSignal(chartInstance.S, 3);
}

static int32_T *c1_codeur_w(void)
{
  return (int32_T *)ssGetOutputPortSignal(chartInstance.S, 4);
}

static void init_dsm_address_info(void)
{
}

static void sf_save_state_c1_test(FILE *c1_file)
{
  fwrite(&chartInstance.c1_is_active_c1_test, 1,
   sizeof(chartInstance.c1_is_active_c1_test), c1_file);
}

static void sf_load_state_c1_test(FILE *c1_file)
{
  fread(&chartInstance.c1_is_active_c1_test, 1,
   sizeof(chartInstance.c1_is_active_c1_test), c1_file);
}

/* SFunction Glue Code */
void sf_c1_test_get_check_sum(mxArray *plhs[])
{
  ((real_T *)mxGetPr((plhs[0])))[0] = (real_T)(1554042472U);
  ((real_T *)mxGetPr((plhs[0])))[1] = (real_T)(400402939U);
  ((real_T *)mxGetPr((plhs[0])))[2] = (real_T)(2616972257U);
  ((real_T *)mxGetPr((plhs[0])))[3] = (real_T)(3838861084U);
}

mxArray *sf_c1_test_get_autoinheritance_info(void)
{
  const char *autoinheritanceFields[] =
  {"checksum","inputs","parameters","outputs"};
  mxArray *mxAutoinheritanceInfo =
  mxCreateStructMatrix(1,1,4,autoinheritanceFields);
  {
    mxArray *mxChecksum = mxCreateDoubleMatrix(4,1,mxREAL);
    double *pr = mxGetPr(mxChecksum);
    pr[0] = (double)(2584522518U);
    pr[1] = (double)(3769943034U);
    pr[2] = (double)(3992427286U);
    pr[3] = (double)(335582761U);
    mxSetField(mxAutoinheritanceInfo,0,"checksum",mxChecksum);
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,5,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(6));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,4,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(6));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,4,"type",mxType);
    }
    mxSetField(mxData,4,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"inputs",mxData);
  }
  {
    mxSetField(mxAutoinheritanceInfo,0,"parameters",mxCreateDoubleMatrix(0,0,mxREAL));
  }
  {
    const char *dataFields[] = {"size","type","complexity"};
    mxArray *mxData = mxCreateStructMatrix(1,4,3,dataFields);
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,0,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,0,"type",mxType);
    }
    mxSetField(mxData,0,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,1,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,1,"type",mxType);
    }
    mxSetField(mxData,1,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,2,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(10));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,2,"type",mxType);
    }
    mxSetField(mxData,2,"complexity",mxCreateDoubleScalar(0));
    {
      mxArray *mxSize = mxCreateDoubleMatrix(1,2,mxREAL);
      double *pr = mxGetPr(mxSize);
      pr[0] = (double)(1);
      pr[1] = (double)(1);
      mxSetField(mxData,3,"size",mxSize);
    }
    {
      const char *typeFields[] = {"base","aliasId","fixpt"};
      mxArray *mxType = mxCreateStructMatrix(1,1,3,typeFields);
      mxSetField(mxType,0,"base",mxCreateDoubleScalar(8));
      mxSetField(mxType,0,"aliasId",mxCreateDoubleScalar(0));
      mxSetField(mxType,0,"fixpt",mxCreateDoubleMatrix(0,0,mxREAL));
      mxSetField(mxData,3,"type",mxType);
    }
    mxSetField(mxData,3,"complexity",mxCreateDoubleScalar(0));
    mxSetField(mxAutoinheritanceInfo,0,"outputs",mxData);
  }
  return(mxAutoinheritanceInfo);
}

static void chart_debug_initialization(SimStruct *S)
{
  if(ssIsFirstInitCond(S)) {
    /* do this only if simulation is starting */
    if(!sim_mode_is_rtw_gen(S)) {
      {
        unsigned int chartAlreadyPresent;
        chartAlreadyPresent = sf_debug_initialize_chart(_testMachineNumber_,
         1,
         1,
         1,
         9,
         0,
         0,
         0,
         0,
         &(chartInstance.chartNumber),
         &(chartInstance.instanceNumber),
         ssGetPath(S),
         (void *)S);
        if(chartAlreadyPresent==0) {
          /* this is the first instance */
          sf_debug_set_chart_disable_implicit_casting(_testMachineNumber_,chartInstance.chartNumber,1);
          sf_debug_set_chart_event_thresholds(_testMachineNumber_,
           chartInstance.chartNumber,
           0,
           0,
           0);

          _SFD_SET_DATA_PROPS(5,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"e",0);
          _SFD_SET_DATA_PROPS(6,1,1,0,SF_INT32,0,NULL,0,0,0,0.0,1.0,0,"codeur",0);
          _SFD_SET_DATA_PROPS(8,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"clk",0);
          _SFD_SET_DATA_PROPS(2,1,1,0,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"e_r",0);
          _SFD_SET_DATA_PROPS(4,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"e_pid",0);
          _SFD_SET_DATA_PROPS(3,1,1,0,SF_INT32,0,NULL,0,0,0,0.0,1.0,0,"codeur_r",0);
          _SFD_SET_DATA_PROPS(0,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"inhibit",0);
          _SFD_SET_DATA_PROPS(1,2,0,1,SF_DOUBLE,0,NULL,0,0,0,0.0,1.0,0,"e_w",0);
          _SFD_SET_DATA_PROPS(7,2,0,1,SF_INT32,0,NULL,0,0,0,0.0,1.0,0,"codeur_w",0);
          _SFD_STATE_INFO(0,0,2);
          _SFD_CH_SUBSTATE_COUNT(0);
          _SFD_CH_SUBSTATE_DECOMP(0);
        }
        _SFD_CV_INIT_CHART(0,0,0,0);
        {
          _SFD_CV_INIT_STATE(0,0,0,0,0,0,NULL,NULL);
        }

        _SFD_CV_INIT_TRANS(0,0,NULL,NULL,0,NULL);

        /* Initialization of EML Model Coverage */
        _SFD_CV_INIT_EML(0,1,2,0,0,0,5,1);
        _SFD_CV_INIT_EML_FCN(0,0,"eML_blk_kernel",0,-1,1070);
        _SFD_CV_INIT_EML_IF(0,0,220,231,391,1070);
        _SFD_CV_INIT_EML_IF(0,1,409,493,868,1061);
        {
          static int condStart[] = {414,431,448,462,474};
          static int condEnd[] = {425,442,456,470,492};
          static int pfixExpr[] = {0,1,-2,2,-2,3,4,-3,-2};
          _SFD_CV_INIT_EML_MCDC(0,0,414,492,5,0,&(condStart[0]),&(condEnd[0]),9,&(pfixExpr[0]));
        }
        _SFD_TRANS_COV_WTS(0,0,0,1,0);
        if(chartAlreadyPresent==0)
        {
          _SFD_TRANS_COV_MAPS(0,
           0,NULL,NULL,
           0,NULL,NULL,
           1,NULL,NULL,
           0,NULL,NULL);
        }
        _SFD_SET_DATA_VALUE_PTR(5U, c1_e());
        _SFD_SET_DATA_VALUE_PTR(6U, c1_codeur());
        _SFD_SET_DATA_VALUE_PTR(8U, c1_clk());
        _SFD_SET_DATA_VALUE_PTR(2U, c1_e_r());
        _SFD_SET_DATA_VALUE_PTR(4U, c1_e_pid());
        _SFD_SET_DATA_VALUE_PTR(3U, c1_codeur_r());
        _SFD_SET_DATA_VALUE_PTR(0U, c1_inhibit());
        _SFD_SET_DATA_VALUE_PTR(1U, c1_e_w());
        _SFD_SET_DATA_VALUE_PTR(7U, c1_codeur_w());
      }
    }
  } else {
    sf_debug_reset_current_state_configuration(_testMachineNumber_,chartInstance.chartNumber,chartInstance.instanceNumber);
  }
}

static void sf_opaque_initialize_c1_test(void *chartInstanceVar)
{
  chart_debug_initialization(chartInstance.S);
  initialize_params_c1_test();
  initialize_c1_test();
}

static void sf_opaque_enable_c1_test(void *chartInstanceVar)
{
  enable_c1_test();
}

static void sf_opaque_disable_c1_test(void *chartInstanceVar)
{
  disable_c1_test();
}

static void sf_opaque_gateway_c1_test(void *chartInstanceVar)
{
  sf_c1_test();
}

static void sf_opaque_terminate_c1_test(void *chartInstanceVar)
{
  finalize_c1_test();
}

static void mdlProcessParameters_c1_test(SimStruct *S)
{
  int i;
  for(i=0;i<ssGetNumRunTimeParams(S);i++) {
    if(ssGetSFcnParamTunable(S,i)) {
      ssUpdateDlgParamAsRunTimeParam(S,i);
    }
  }
  initialize_params_c1_test();
}

static void mdlSetWorkWidths_c1_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    int_T chartIsInlinable =
      (int_T)sf_is_chart_inlinable("test",1);
    ssSetStateflowIsInlinable(S,chartIsInlinable);
    ssSetEnableFcnIsTrivial(S,1);
    ssSetDisableFcnIsTrivial(S,1);
    ssSetNotMultipleInlinable(S,sf_rtw_info_uint_prop("test",1,"gatewayCannotBeInlinedMultipleTimes"));
    if(chartIsInlinable) {
      ssSetInputPortOptimOpts(S, 0, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 1, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 2, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 3, SS_REUSABLE_AND_LOCAL);
      ssSetInputPortOptimOpts(S, 4, SS_REUSABLE_AND_LOCAL);
      sf_mark_chart_expressionable_inputs(S,"test",1,5);
      sf_mark_chart_reusable_outputs(S,"test",1,4);
    }
    if (!sf_is_chart_instance_optimized_out("test",1)) {
      int dtId;
      char *chartInstanceTypedefName =
        sf_chart_instance_typedef_name("test",1);
      dtId = ssRegisterDataType(S, chartInstanceTypedefName);
      if (dtId == INVALID_DTYPE_ID ) return;
      /* Register the size of the udt */
      if (!ssSetDataTypeSize(S, dtId, 8)) return;
      if(!ssSetNumDWork(S,1)) return;
      ssSetDWorkDataType(S, 0, dtId);
      ssSetDWorkWidth(S, 0, 1);
      ssSetDWorkName(S, 0, "ChartInstance"); /*optional name, less than 16 chars*/
      sf_set_rtw_identifier(S);
    }
    ssSetHasSubFunctions(S,!(chartIsInlinable));
    ssSetOptions(S,ssGetOptions(S)|SS_OPTION_WORKS_WITH_CODE_REUSE);
  }

  ssSetChecksum0(S,(552303319U));
  ssSetChecksum1(S,(1228142798U));
  ssSetChecksum2(S,(925079494U));
  ssSetChecksum3(S,(3472391228U));

  ssSetExplicitFCSSCtrl(S,1);
}

static void mdlRTW_c1_test(SimStruct *S)
{
  if(sim_mode_is_rtw_gen(S)) {
    sf_write_symbol_mapping(S, "test", 1);
    ssWriteRTWStrParam(S, "StateflowChartType", "Embedded MATLAB");
  }
}

static void sf_save_debug_c1_test(SFc1_testInstanceStruct* chartInstance, FILE*
 file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = sf_debug_get_state_vectors_data_size(machineNumber,
   chartNumber, instanceNumber);
  unsigned char* buffer = (unsigned char*) malloc(bufferSize);
  unsigned int chartActive = sf_debug_get_chart_active(machineNumber,
   chartNumber, instanceNumber);
  fwrite(&chartActive, sizeof(chartActive),1,file);
  sf_debug_get_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  fwrite(&bufferSize, sizeof(bufferSize), 1, file); /* Write number of bytes */
  fwrite(buffer, 1, bufferSize,file);   /* Write buffer */
  free(buffer);
}
static void sf_load_debug_c1_test(SFc1_testInstanceStruct* chartInstance,FILE*
 file)
{
  int machineNumber = _testMachineNumber_;
  int chartNumber = chartInstance->chartNumber;
  int instanceNumber = chartInstance->instanceNumber;
  int bufferSize = 0;
  unsigned char* buffer = NULL;
  unsigned int chartActive = 0;
  fread(&chartActive, sizeof(chartActive),1,file);
  sf_debug_set_chart_active(machineNumber, chartNumber, instanceNumber,
   chartActive);
  fread(&bufferSize, sizeof(bufferSize), 1, file);
  buffer = (unsigned char*) malloc(bufferSize);
  fread(buffer, 1, bufferSize, file);
  sf_debug_set_state_vectors_data(machineNumber, chartNumber, instanceNumber,
   buffer, bufferSize);
  free(buffer);
}
static void sf_c1_test_sim_ctx_io(SimStruct* S, const char io, FILE* file)
{
  if(io == 'r') {
    sf_load_state_c1_test(file);
    sf_load_debug_c1_test(&chartInstance, file);
  } else {
    sf_save_state_c1_test(file);
    sf_save_debug_c1_test(&chartInstance, file);
  }
}
static void mdlStart_c1_test(SimStruct *S)
{
  chartInstance.chartInfo.chartInstance = NULL;
  chartInstance.chartInfo.isEMLChart = 1;
  chartInstance.chartInfo.chartInitialized = 0;
  chartInstance.chartInfo.sFunctionGateway = sf_opaque_gateway_c1_test;
  chartInstance.chartInfo.initializeChart = sf_opaque_initialize_c1_test;
  chartInstance.chartInfo.terminateChart = sf_opaque_terminate_c1_test;
  chartInstance.chartInfo.enableChart = sf_opaque_enable_c1_test;
  chartInstance.chartInfo.disableChart = sf_opaque_disable_c1_test;
  chartInstance.chartInfo.mdlRTW = mdlRTW_c1_test;
  chartInstance.chartInfo.mdlStart = mdlStart_c1_test;
  chartInstance.chartInfo.mdlSetWorkWidths = mdlSetWorkWidths_c1_test;
  chartInstance.chartInfo.restoreLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.restoreBeforeLastMajorStepConfiguration = NULL;
  chartInstance.chartInfo.storeCurrentConfiguration = NULL;
  chartInstance.S = S;
  ssSetUserData(S,(void *)(&(chartInstance.chartInfo))); /* register the chart instance with simstruct */
  ssSetmdlSimulationContextIO(S, sf_c1_test_sim_ctx_io);
  if(!sim_mode_is_rtw_gen(S)) {
    init_dsm_address_info();
  }
}

void c1_test_method_dispatcher(SimStruct *S, int_T method, void *data)
{
  switch (method) {
   case SS_CALL_MDL_START:
    mdlStart_c1_test(S);
    break;
   case SS_CALL_MDL_SET_WORK_WIDTHS:
    mdlSetWorkWidths_c1_test(S);
    break;
   case SS_CALL_MDL_PROCESS_PARAMETERS:
    mdlProcessParameters_c1_test(S);
    break;
   default:
    /* Unhandled method */
    sf_mex_error_message("Stateflow Internal Error:\n"
     "Error calling c1_test_method_dispatcher.\n"
     "Can't handle method %d.\n", method);
    break;
  }
}

